#ifndef BW_FILTER
#define BW_FILTER
/*----------------------------------------------------------------------
 * $Id: bwFilter.h,v 1.7 2004/04/20 00:31:38 ganzhorn Exp $             
 *                                                                      
 * Copyright (C)   2004            Salem Ganzhorn <eyekode@yahoo.com> 
 *                                                                      
 * This file may be distributed and/or modified under the terms of the  
 * Q Public License as defined by Trolltech AS of Norway and appearing  
 * in the file LICENSE.QPL included in the packaging of this file.      
 *                                                                      
 *----------------------------------------------------------------------*/

#include <qslider.h>
#include <qframe.h>
#include <qcheckbox.h>
#include <qradiobutton.h>

class bwFilter : public QFrame {
   Q_OBJECT;
  public:
   bwFilter( Qt::Orientation o, QWidget *parent,const char *name=0 );

   static void convert( QImage& image,
			double r=.11,
			double g=.59,
			double b=.30 );

  signals:
   void filterChanged();
   void luminosity(const QString &);
   void luminosityR(const QString &);
   void luminosityG(const QString &);
   void luminosityB(const QString &);

  public slots:
     void filter( QImage &image ) const;
  void setLuminosity( int l );
  void setR(int r);
  void setG(int g);
  void setB(int b);

  protected slots:
     void previewR();
     void previewG();
     void previewB();

  protected:   
   double r() const {return m_color[0];}
   double g() const {return m_color[1];}
   double b() const {return m_color[2];}
   void preview(int);
   void update( int idx ); // update other Idx values

  protected:
   double     m_color[3];
   int        m_luminosity;
   QCheckBox *m_lock[3];
   QSlider   *m_slider[3];
   QRadioButton *m_preview[3];
   bool       m_updating;
   bool       m_inPreview;
};

#endif
