#ifndef IMAGE_DISPLAY
#define IMAGE_DISPLAY
/*----------------------------------------------------------------------
 * $Id: imageDisplay.h,v 1.6 2004/04/12 01:21:22 ganzhorn Exp $             
 *                                                                      
 * Copyright (C)   2004            Salem Ganzhorn <eyekode@yahoo.com> 
 *                                                                      
 * This file may be distributed and/or modified under the terms of the  
 * Q Public License as defined by Trolltech AS of Norway and appearing  
 * in the file LICENSE.QPL included in the packaging of this file.      
 *                                                                      
 *----------------------------------------------------------------------*/

#include <qframe.h>
#include <qimage.h>
#include <qpixmap.h>

class ImageDisplay : public QFrame {
   Q_OBJECT;
  public:
    ImageDisplay( QWidget * parent = 0, const char * name = 0 );
    virtual ~ImageDisplay();

  public:
    void setImage( const QString &filename );
    const QString & filename() const {return m_filename;}

  signals:
    void imageChanged( QImage &image ); // used for implimenting filters

  public slots:
    void refresh(); // refilter
    void saveAs();
     
  protected:
    virtual void paintEvent ( QPaintEvent * event );
    virtual void resizeEvent ( QResizeEvent * e );

  protected:
    void updatePixmap( const QSize& size );

  protected:
    QString   m_filename;
    QImage    m_image,m_resized;
    QPixmap   m_pixmap;
};

#endif
