#ifndef IMGVIEW_MAIN_H
#define IMGVIEW_MAIN_H
/*----------------------------------------------------------------------
 * $Id: main.h,v 1.16 2004/04/20 00:34:01 ganzhorn Exp $             
 *                                                                      
 * Copyright (C)   2004            Salem Ganzhorn <eyekode@yahoo.com> 
 *                                                                      
 * This file may be distributed and/or modified under the terms of the  
 * Q Public License as defined by Trolltech AS of Norway and appearing  
 * in the file LICENSE.QPL included in the packaging of this file.      
 *                                                                      
 *----------------------------------------------------------------------*/

#include <qmainwindow.h>
#include <qdir.h>
#include <qlistbox.h>
#include <qiconview.h>
#include <qsplitter.h>
#include <qpopupmenu.h>

#include "history.h"

#define PROGRAM "tonality"
#define VERSION "1.1"

class ImageDisplay;

class PopupMenuBool : public QObject {
   Q_OBJECT
  public:
   PopupMenuBool(QPopupMenu *menu,const QString& text,bool initialValue);


  public:
   bool value() const;
   
  signals:
   void valueChanged( bool value );

   public slots:
      void toggle();

   protected slots:
      void preMenuPost();

  protected:
   bool        m_value;
   int         m_index;
   QPopupMenu *m_menu;
};

class MainWindow : public QMainWindow {
    Q_OBJECT
  public:
    MainWindow( 
	QWidget*parent     = NULL,
	const char * name  = NULL,
	WFlags f = WType_TopLevel
	);
    ~MainWindow();

  public:
    QListBox     *files() {return m_listbox;}
    QDir         *cwd() {return &m_cwd;}

  public:
    QPixmap thumbNail( const QString& filename );

  public slots:
    bool cd( const QString &path, bool force = false );
    bool refresh(); // clears/recalculates thumbnails
    void reload();  // reloads thumbnails
    void selectionChanged();
    void next(); // next dir with images
    void prev(); // previous dir with images
    void updateCaption();

  signals:
    void dirChanged( const QString &path );

  private:
    history<QString> m_history;
    QDir           m_cwd;
    QSplitter     *m_splitter;
    QListBox      *m_listbox;
    QIconView     *m_iconview;
    ImageDisplay  *m_imagedisplay;
    bool           m_inHistory;
    PopupMenuBool *m_bwThumbnails;
};

#endif
